Ruby - Bug #6144

regexec may allocate extra memory?
03/14/2012 07:44 PM - mame (Yusuke Endoh)

Status: Closed

Priority: Normal

Assignee: naruse (Yui NARUSE)

Target version:

ruby -v: ruby 2.0.0dev (2012-03-14 trunk 35017) |Backport:
[i1686-linux]

Description

naruse (10 0k-takata [0

goooo

000000D000000regexec.c O

alloc_addr = (char™ )xalloca(sizeof(char*) * (ptr_num));\

1000000000 #define STACK_INIT [)
00o000oooo

alloc_addr = (char™ )xalloca(sizeof(char) * (ptr_num));\
aaa

alloc_addr = (char** )xalloca(sizeof(char*) * (ptr_num));\
(000 coverity Scan 00000000000000

Yusuke Endoh mame@tsg.ne.jp

History

#1 - 03/16/2012 12:21 AM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

000o00ooonoooooobonnoooDonDa

diff --git a/regexec.c b/regexec.c

index 2587cd9..9e31c71 100644

--- a/regexec.c

+++ b/regexec.c

@@ -446,16 +446,16 @@ onig_region_copy(OnigRegion* to, OnigRegion* from)

#define STACK_INIT(alloc_addr, ptr_num, stack_num) do {
if (msa->stack_p) {\

e alloc_addr = (char* )xalloca(sizeof(char*) * (ptr_num));\

¢ alloc_addr = (char* )xalloca(sizeof(OnigStackindex*) * (ptr_num));
stk_alloc = (OnigStackType* )(msa->stack_p);
stk_base = stk_alloc;
stk = stk_base;
stk_end =stk_base + msa->stack n;

}

else {\

e alloc_addr = (char* )xalloca(sizeof(char*) * (ptr_num)\

06/17/2025 12



mailto:mame@tsg.ne.jp

e alloc_addr = (char* )xalloca(sizeof(OnigStackindex*) * (ptr_num)
+ sizeof(OnigStackType) * (stack_num));\

e stk_alloc = (OnigStackType* )(alloc_addr + sizeof(char*) * (ptr_num));\

¢ stk_alloc = (OnigStackType* )(alloc_addr + sizeof(OnigStackindex*) * (ptr_num));

stk_base = stk_alloc;
stk = stk_base;
stk_end = stk_base + (stack_num);\

#2 - 03/16/2012 12:36 AM - k_takata (Ken Takata)

alloc_addr 0oooo OnigStackIindex* DDDDDDDDDOnigStaekIndex 000000000ooooon
OnigStackindex [ intptr_t [ typedef D0000xalloca 00000000000000000
(10000000000 char- 000DOO0DDOOODDOOODDODOD

alloc_addr = (OnigStackindex* )xalloca(sizeof(OnigStackindex) * (ptr_num));\

000boboboDoDopopooD...o

#3 - 03/16/2012 12:43 AM - k_takata (Ken Takata)

00000000000 char 0OOCDOODOODOOODOODOORODD
00stk_alloc 0000000 char+ 00000000000000D0DO0DODD

#4 - 03/21/2012 01:35 AM - k_takata (Ken Takata)
sizeof(char*)sizeof(OnigStackindex)I 0000000

https://github.com/k-takata/Onigmo/tree/tmp/ruby-2.0.x

#5 - 03/22/2012 09:21 AM - naruse (Yui NARUSE)

- Status changed from Assigned to Closed
